﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.Device.Location;
using System.IO.IsolatedStorage;

namespace GPS_Distance
{
    public partial class MainPage : PhoneApplicationPage
    {
#if false
        public static System.Windows.Threading.Dispatcher MyDispatcher;
#endif
        // コンストラクター
        public MainPage()
        {
            InitializeComponent();
            DataContext = App.ViewModel;
#if false
            MyDispatcher = this.Dispatcher;
#endif
        }

        private const string warntext = @"本ソフトは現在位置を取得するためにGPSを使用します。GPSの利用を許可する場合はOKを選択して下さい。許可しない場合はキャンセルを選択して下さい。";

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (MessageBox.Show(warntext, "GPS距離計", MessageBoxButton.OKCancel) != MessageBoxResult.OK) return;
            if (!App.ViewModel.IsDataLoaded)
            {
                App.ViewModel.LoadData();
            }
        }

        private const string helptext = @"本ソフトは2点間の距離を計算します。本ソフトを使用するには、まず距離の始点になる場所で『基準点をここに設定』をタップして確定させます。その後、移動してから本ソフトを使用すると距離が分かります。その間、ソフトは閉じても構いません。APIを使用した場合、地球を球と仮定したHaversine式が使用されます。Yahooのサービスを使用した場合楕円として計算します。高度は距離の計算に使用されません。GPSにアクセスできない状況では距離を計算できません。GPS Accessのサインが点滅していない場合は、最後にアクセスしたGPS情報による距離が表示されているだけであり、現在位置との距離は示していません。圏外ではYahooのサービスも使用できません。";

        private void ApplicationBarIconButton_Click(object sender, EventArgs e)
        {
            MessageBox.Show(helptext);
        }

        private void ApplicationBarIconButton_Click_1(object sender, EventArgs e)
        {
            NavigationService.Navigate(new Uri("/GeoGeo.xaml", UriKind.Relative));
        }

        private void ApplicationBarIconButton_Click_2(object sender, EventArgs e)
        {
            NavigationService.Navigate(new Uri("/Settings.xaml", UriKind.Relative));
        }
    }
}
