﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Linq;
using System.Xml.Linq;
using System.Device.Location;

namespace GPS_Distance
{
    public class Yahoo
    {
        private static double nowDistance;
        private static GeoCoordinate nowCurrentPoint=new GeoCoordinate();
        private static GeoCoordinate nowBasePoint = new GeoCoordinate();
        private static bool transfering;
        internal static double Distance(GeoCoordinate current, GeoCoordinate basepoint)
        {
            if (transfering) return nowDistance;
            if (nowCurrentPoint.Equals(current) && nowBasePoint.Equals(basepoint)) return nowDistance;
            const string urlFormat = "http://distance.search.olp.yahooapis.jp/OpenLocalPlatform/V1/distance?coordinates={0},{1} {2},{3}&appid=(自分で取得したIDに置き換える)";
            string url = string.Format(urlFormat, current.Longitude, current.Latitude, basepoint.Longitude, basepoint.Latitude);
            var client = new WebClient();
            transfering = true;
            client.DownloadStringCompleted += new DownloadStringCompletedEventHandler((sender, e) =>
            {
                var ns = XNamespace.Get("http://olp.yahooapis.jp/ydf/1.0");
                var doc = XDocument.Parse(e.Result);
                var elem = doc.Descendants(ns + "Distance").FirstOrDefault();
                if (elem == null) nowDistance = 0.0;
                else nowDistance = double.Parse(elem.Value) * 1000.0;
                transfering = false;
            });
            client.DownloadStringAsync(new Uri(url));
            nowCurrentPoint = current;
            nowBasePoint = basepoint;
            return nowDistance;
        }
    }
}
