﻿using System.Runtime.Serialization;
using System.IO;
using System.Runtime.Serialization.Json;
using JpegGps;

namespace CloudWebRole.Plotier002
{
    [DataContract]
    public class Body
    {
        [DataMember]
        public SingleData[] data;
    }

    [DataContract]
    public class NameAndIdPair
    {
        [DataMember]
        public string name;
        [DataMember]
        public string id;
    }

    [DataContract]
    public class SharedWith
    {
        [DataMember]
        public string access;
    }

    [DataContract]
    public class SingleData
    {
        [DataMember]
        public string id;
        [DataMember]
        public NameAndIdPair from;

        [DataMember]
        public string name;
        [DataMember]
        public string description;
        [DataMember]
        public string parent_id;
        [DataMember]
        public int size;
        [DataMember]
        public string upload_location;
        [DataMember]
        public string comments_count;
        [DataMember]
        public bool comments_enabled;
        [DataMember]
        public bool is_embeddable;
        [DataMember]
        public string source;
        [DataMember]
        public string link;
        [DataMember]
        public string type;
        [DataMember]
        public SharedWith shared_with;
        [DataMember]
        public string created_time;
        [DataMember]
        public string updated_time;
    }
    public static class Plotier002Util
    {
        private static DataContractJsonSerializer ser = new DataContractJsonSerializer(typeof(Body));
        public static Body Deserialize(string json)
        {
            return (Body)ser.ReadObject(new MemoryStream(System.Text.Encoding.UTF8.GetBytes(json)));
        }
        public static double ConvDtoS(JpegGpsValue d)
        {
            bool plus = d.Prefix == 'E' || d.Prefix == 'N';
            double sign = plus ? 1.0 : -1.0;
            return sign * (d.Dd + d.Mm / 60.0 + d.Ss / 3600.0);
        }
    }
}
