﻿using System;
using System.Linq;
using System.Web;
using System.Net;
using System.IO;

namespace CloudWebRole.Plotier002
{
    public partial class UploadProxy : System.Web.UI.Page
    {
        public static void UploadOverwriteFile(string fileId, Stream readStream, string folderLocation, string accessToken)
        {
            var urlList = "https://apis.live.net/v5.0/" + folderLocation + "/files?access_token=" + HttpUtility.UrlEncode(accessToken);
            var client = new WebClient();
            client.Encoding = System.Text.Encoding.UTF8;
            var r = client.DownloadString(urlList);
            var body = Plotier002Util.Deserialize(r);

            var file = body.data.FirstOrDefault(c => c.id == fileId);

            var url = file.upload_location + "?access_token=" + HttpUtility.UrlEncode(accessToken) + "&overwrite=true";
            HttpWebRequest webRequest = HttpWebRequest.Create(url) as HttpWebRequest;
            webRequest.Method = "PUT";
            using (Stream webStream = webRequest.GetRequestStream())
            {
                int size = 4096, n;
                byte[] buf = new byte[size];
                while ((n = readStream.Read(buf, 0, size)) > 0) webStream.Write(buf, 0, n);
                webStream.Close();
            }
            using (HttpWebResponse webResponse = webRequest.GetResponse() as HttpWebResponse)
            {
                if (webResponse.StatusCode != HttpStatusCode.Created && webResponse.StatusCode != HttpStatusCode.OK)
                    throw new Exception("Failed to save document (Status : " + webResponse.StatusCode + ")");
            }
        }
        public static void UploadNewFile(string newname, Stream readStream, string folderLocation, string accessToken)
        {
            var url = "https://apis.live.net/v5.0/" + folderLocation + "/files/"
                + newname + ".txt?access_token=" + HttpUtility.UrlEncode(accessToken) + "&overwrite=false";
            HttpWebRequest webRequest = HttpWebRequest.Create(url) as HttpWebRequest;
            webRequest.Method = "PUT";
            webRequest.ContentType = "";
            var stream = new MemoryStream();
            int size = 4096, n;
            byte[] buf = new byte[size];
            while ((n = readStream.Read(buf, 0, size)) > 0) stream.Write(buf, 0, n);
            stream.Close();
            var ar = stream.ToArray();
            webRequest.ContentLength = ar.Length;
            using (Stream webStream = webRequest.GetRequestStream())
            {
                using (Stream memStream = new MemoryStream(ar))
                {
                    while ((n = memStream.Read(buf, 0, size)) > 0) webStream.Write(buf, 0, n);
                }
            }
            using (HttpWebResponse webResponse = webRequest.GetResponse() as HttpWebResponse)
            {
                if (webResponse.StatusCode != HttpStatusCode.Created && webResponse.StatusCode != HttpStatusCode.OK)
                    throw new Exception("Failed to save document (Status : " + webResponse.StatusCode + ")");
            }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Request["newname"]))
                UploadOverwriteFile(Request["id"], Request.InputStream, Request["folderid"], Request["access_token"]);
            else
                UploadNewFile(Request["newname"], Request.InputStream, Request["folderid"], Request["access_token"]);
        }
    }
}
